bool init_ports(void);	
bool init_timers(void);	
bool init_uart(void);
bool init_ADC(void);

bool init_ports(void)
{	
	//PORT A
	//PA0 IR_IN
	//PA1 LED
	//PA2 IN3
	//PA3 IN4
	//PA4 SCK
	//PA5 MISO
	//PA6 MOSI
	//PA7 IR_OUT
	DDRA |=  0b10100010;
	DDRA &= ~0b01011101;
	
	//PORTB
	//PB0 IN1
	//PB1 IN2
	//PB2 OC0A
	DDRB |=  0x04;
	DDRB &= ~0x03;
	
	return true;
}

bool init_timers(void)
{
/*
	// Servo output
	// Clock source: System Clock. Clock value: 8MHz
	// Mode: Fast PWM: top=OCR0A. WGM 101
	// OC0A output: Non-Inv. OC0B output: Non-Inv
	TCCR0A = 0b10110011;	//OC0A: Clear on comp-match/set at bottom, OC0B: Set on comp-match/clear at bottom
	TCCR0B = 0b00000101;	//Clock prescaling 1024 (TCNT0 = 256-156 = 50z overflow)
	TIMSK0 |= 0b00000101;	//Timer overflow +Comp-matchB interrupt enable
	OCR0A  = 100;			//SERVO 108 - 115
	OCR0B  = 100; 			//IR_out
	TCNT0  = 100;		    //Generate 50Hz PWM Signal 
*/

	//Servo/IR output
	//Clock source: System Clock 8MHz
	//Mode: Phase Correct PWM, top = 0xFF 
	//Servo: Clear on comp-match when up-counting, set on comp-match when down-counting
	//IR: set on comp-match when up-counting, clear on comp-match when down-counting
	TCCR0A = 0b10110001;	
	//TCCR0A = 0b00110001;	
	//PORTA |= 0b10000000;	//turn off IRout
	TCCR0B = 0b00000100; //Prescaling 256, frequency 61Hz
	TIMSK0 = 0b00000101; //Timer overflow interrupt, and comp match B interrupt
	OCR0A = 17; //17 = 1.1ms, 30 = 1.9ms
	OCR0B = 17;
	return true;
}

bool init_ADC(void)
{
	//setup adc single conversion-mode, left adjust result
	ADMUX   =  0b00000000; //AVCC reference, read ADC0 
	ADCSRB &= ~0b00010111; //Free Running mode, Right adjust result
	ADCSRA  =  0b10001110; //Enable ADC, enable interrupt, prescale 64 (125kHz)
	return true;
}

